!
subroutine AIG2R(A,N)
! Обращение вещественной матрицы методом Жордана
! с выбором ведущего элемента по всей матрице
! http://num-anal.srcc.msu.ru/lib_na/cat/ai/aig2r.htm
real:: A(:,:)
integer, intent(in):: N
real, allocatable:: S(:,:)
integer F,G,O,P,Q,R,T,U,BB,BD,J,I,M,K,L
real W,BA,BJ,BN,BQ,BE,X,Y,Z
real, parameter:: ZERO=0.0
!
    if (N==1) then
        A(1,1)=1./A(1,1); return
    end if
    allocate(S(N,2))
    F=1; G=1
1   continue    
    U=G; W=ZERO
    DO 3 J=G,N
        BB=F; BA=ZERO
        if (F.GT.N) goto 22
        DO 2 I=F,N
            BJ=abs(A(I,J))
            if (BA.GE.BJ) goto 2
            BA=BJ; BB=I
2       continue
22      if (W.GT.BA) goto 3
        W=BA; T=BB; U=J
3   continue
    do I=1,N,1
        BN=A(I,U); A(I,U)=A(I,F); A(I,F)=BN
    end do
    do J=1,N,1
        BQ=A(T,J); A(T,J)=A(F,J); A(F,J)=BQ
    end do
    S(F,2)=U; S(F,1)=T
    J=G
    X=1./A(F,F)
    do I=1,N,1
        A(I,F)=-(A(I,F)*X)
    end do
    A(F,F)=X
    O=0
7   O=O+1
    if (O.EQ.F) goto 7
    if (N.LT.O) goto 10
    BE=A(F,O)
    BD=F-1
    if (BD.EQ.0) goto 23
    do P=1,BD,1
        A(P,O)=A(P,O)+A(P,F)*BE
    end do
23  BD=F+1
    if (BD.GT.N) goto 7
    do P=BD,N,1
        A(P,O)=A(P,O)+A(P,F)*BE
    end do    
    goto 7
10  M=J+1
    if (M.GT.N) goto 24
    do O=M,N,1
        A(F,O)=A(F,O)*A(F,G)
    end do
24  M=J-1
    if (M.EQ.0) goto 25
    do O=1,M,1
        A(F,O)=A(F,O)*A(F,G)
    end do
25  F=F+1; G=G+1
    if (F.GT.N) goto 13
    if (G.LE.N) goto 1
13  J=1
14  Q=ISIGN(1,1-N)
    K=N-Q
15  K=K+Q
    I=S(K,2)
    Y=A(I,J); A(I,J)=A(K,J); A(K,J)=Y
    if (K.NE.1) goto 15
    J=J+1
    if (J.LE.N) goto 14
    I=1
16  R=ISIGN(1,1-N)
    L=N-R
17  L=L+R
    J=S(L,1)
    Z=A(I,J); A(I,J)=A(I,L); A(I,L)=Z
    if (L.NE.1) goto 17
    I=I+1
    if (I.LE.N) goto 16
    deallocate(S)
    return
end subroutine AIG2R
